// .NET Framework 2.0 Demos
// (C) Dr. Holger Schwichtenberg
// http://www.dotnetframework.de
// =====================================
using System;
using de.ITVisions.DemoViewer;

namespace de.Tennis
{
 
    public class Doppel<PartnerTyp1,PartnerTyp2>
    {
        public PartnerTyp1 Partner1;
        public PartnerTyp2 Partner2;

        public Doppel(PartnerTyp1 Partner1, PartnerTyp2 Partner2)
        {
            this.Partner1 = Partner1;
            this.Partner2 = Partner2;
            Console.WriteLine("Partner 1 = " + Partner1.GetType().ToString());
            Console.WriteLine("Partner 2 = " + Partner2.GetType().ToString());
            if ((Partner1.GetType().ToString() != Partner2.GetType().ToString()))
            {
               Demo.Print("Neues Gemischtes Doppelt!");
            }
            else
            {
             Demo.Print("Neues Gleichgeschlechtliches Doppel!");
            }
            Demo.Print((this.Partner1 as Mensch).name + "/" + (this.Partner2 as Mensch).name);
        }

    }



    public class Mensch
    {
       public string name;
    }

    public class Mann: Mensch
    {
     public Mann(string Name)
     {
      this.name = Name;
     }
   
    }

    public class Frau: Mensch
    {
      public Frau(string Name)
     {
      this.name = Name;
     }
   
    }


 [Demo]
    public class GenerischeKlasse_demo
    {
        public void run()
        {
         Frau f = new Frau("Angela Merkel");
         Mann m1 = new Mann("Gerhard Schrder");
         Mann m2 = new Mann("Edmund Stoiber");
		 System.IO.FileInfo f2 = new System.IO.FileInfo(@"c:\test");
         
         Doppel<Mann,Frau> d1 = new Doppel<Mann,Frau>(m1, f);
		Doppel<Mann, Mann> d2 = new Doppel<Mann, Mann>(m1, m2);

            // Fehler:
		//Doppel<Mann, Mann> d2 = new Doppel<Mann, Mann>(m1, f);
		//Doppel<Mensch, Mensch> d2 = new Doppel<Mensch, Mensch>(m1, f2);

       //  Doppel<int, string> f2 = new Doppel<int, string>(2, "2");




		System.Collections.Generic.SortedDictionary<string, System.IO.FileInfo> dateien =
			new System.Collections.Generic.SortedDictionary<string, System.IO.FileInfo>();

		dateien.Add("Protokoll",new System.IO.FileInfo(@"c:\temp\Protokoll.txt"));
		dateien.Add("Eingabe",new System.IO.FileInfo(@"c:\temp\Eingabe.txt"));
		dateien.Add("Ausgabe", new System.IO.FileInfo(@"c:\temp\"));
		
		System.Collections.Generic.List<Mann> MaennerClub = new System.Collections.Generic.List<Mann>();

          //  MaennerClub.Add(new Mann());
            //Fehler
            //MaennerClub.Add(new Frau());
        }
    }
}
