﻿#region Using directives

using System;
using System.Collections.Generic;
using System.Text;

#endregion
using de.WWWings;

namespace de.WWWings
{
 [Serializable()]
 public partial class Flug
 {
  public Flug()
  { }

  #region Konstruktoren
  // ========== Konstruktor 1
  public Flug(string FlugNr, string AbflugOrt, string ZielOrt)
  {
   this.FlugNr = FlugNr;
   this.AbflugOrt = AbflugOrt;
   this.ZielOrt = ZielOrt;
   if (Flug.Fluege.ContainsKey(this.FlugNr.ToString())) Flug.Fluege.Remove(this.FlugNr.ToString());
   Flug.Fluege.Add(this.FlugNr.ToString(), this);
  }
  // ========== Konstruktor 2
  public Flug(string FlugNr, string AbflugOrt, string ZielOrt, DateTime Datum)
   : this(FlugNr, AbflugOrt, ZielOrt)
  {
   this.Datum = Datum;
  }
  #endregion


  // ========== Operatorüberladung
  public static Flug operator +(Flug flug, de.WWWings.PassagierSystem.Passagier pass)
  {
   pass.Buchen(flug);
   return flug;
  }

  public static de.WWWings.Flug GetFlug(long FlugNr)
  {
   System.Data.Common.DbDataReader dr = new de.WWWings.DAL.Flug_DataManager().GetFlug_DR(FlugNr);
   Flug f = new Flug(FlugNr.ToString(), dr["fl_abflugort"].ToString(), dr["fl_zielort"].ToString());
   return f;
  }

  public override string ToString()
  {
   return "von " + this.AbflugOrt + " nach " + this.ZielOrt;
  }
 }
}


