﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsUI
{
 public partial class F_Flugverwaltung_Webservice : Form
 {
  public F_Flugverwaltung_Webservice()
  {
   InitializeComponent();
  }

  private void Flugverwaltung_Webservice_Load(object sender, EventArgs e)
  {

  }

  private void openToolStripButton_Click(object sender, EventArgs e)
  {
   WWWingsServer.WorldWideWingsFlugplanWebservice ws = new WindowsUI.WWWingsServer.WorldWideWingsFlugplanWebservice();
   this.C_FlugTabelle.DataSource = ws.GetAllFlights().Tables[0];
  }

  // Speichern des GridView
  private void saveToolStripButton_Click(object sender, EventArgs e)
  {
   WWWingsServer.WorldWideWingsFlugplanWebservice ws = new WindowsUI.WWWingsServer.WorldWideWingsFlugplanWebservice();
   DataSet ds, aenderungen;
   ds = ((DataTable)this.C_FlugTabelle.DataSource).DataSet;
   // Änderungen ermitteln
   if (ds.HasChanges())
   {
    aenderungen = ds.GetChanges();
    // Änderungen an Webservice übergeben
    try
    {
     ws.UpdateFlights(aenderungen);
     ds.AcceptChanges();
    }
    catch (System.Web.Services.Protocols.SoapException ex)
    {
     System.Windows.Forms.MessageBox.Show("Fehler: " + ex.Message, "Fehler beim Aufruf des Webservice");
    }
   }
  }

  private void newToolStripButton_Click(object sender, EventArgs e)
  {
   this.C_FlugTabelle.DataSource = null;
  }

  private void helpToolStripButton_Click(object sender, EventArgs e)
  {
   System.Windows.Forms.MessageBox.Show(".NET 2.0 Crashkurs. Beispiel aus dem Kapitel 'Fernaufruf/Webservices'");
  }

  private void C_FlugTabelle_CellContentClick(object sender, DataGridViewCellEventArgs e)
  {

  }

  private void C_ToolStrip_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
  {
  
  }



 }
}