﻿
' Option Strict On
Imports de.WWWings
Imports de.WWWings.PassagierSystem

Namespace de.WWWings



 Public Class FluggesellschaftClient

  Dim WithEvents pass As Passagier
  Public Shared Sub run()
   Dim f1 As New Flug("NF1234", "Düsseldorf", "München")
   Dim f2 As New Flug("NF5678", "Düsseldorf", "New York")
   Dim p1 As New Passagier("Schröder", "Gerhard")
   Dim p2 As New Passagier("Merkel", "Angela")

   AddHandler Passagier.CheckInStart, AddressOf CheckInStartHandler
   ' AddHandler Passagier.CheckInEnde, AddressOf CheckInEndeHandler

   p1.Buchen("NF1234")
   p1.Buchen("NF5678")
   f1 = f1 + p2 ' Entspricht       p2.Buchen("NF1234")
   p1.CheckIn("NF1234")

   Try
    p2.CheckIn("NF5678")
   Catch ex As PassagierNichtAufFlugGebucht
    Console.WriteLine("Einchecken nicht möglich, da Passagier nicht auf diesen Flug gebucht ist!")
   Catch ex As Exception
    Console.WriteLine("Es ist ein unerwarteter Fehler aufgetreten: " & ex.Message)
   End Try
   Console.WriteLine("Gesamtanzahl der Flüge: " & Flug.Fluege.Count)
   Console.WriteLine("Gesamtanzahl der Passagiere: " & Passagier.Passagiere.Count)
   For Each p As Passagier In CType(Passagier.Passagiere.Values, IEnumerable(Of Passagier))
    Console.WriteLine(p.GanzerName & " hat " & p.Fluege.Count & " gebucht!")
    'If p.AktuellerFlug IsNot Nothing Then Console.WriteLine("Aktueller Flug: " & p.AktuellerFlug.FlugNr)
   Next


   Dim pass As New Passagier("Schröder", "Gerhard")
   Dim pers As New Person("Merkel", "Angela")
   pers = pass
   ' pass = pers ' Erlaubt ohne Option Strict!
   pass = CType(pers, Passagier)
   pass.Info()
   pers.Info()

   Dim zahl As Integer = 1
   Dim text As String = zahl

  End Sub

  Shared Sub CheckInStartHandler(ByVal pass As Passagier)
   Console.WriteLine("Check-In beginnt... für " & pass.GanzerName)
  End Sub

  Shared Sub CheckInEndeHandler(ByVal pass As Passagier) Handles pass.CheckInEnde
   Static AnzahlPass As Int16 = 0
   AnzahlPass += 1
   Console.WriteLine(AnzahlPass & ". Passagier: " & pass.GanzerName)
  End Sub


 End Class

 Public Class pilot

  Sub x()

  End Sub
 End Class
End Namespace
