<TestClass()> Public Class UnitTest1

    ''' <summary>
    ''' Initialize() is called once during test execution before
    ''' test methods in this test class are executed.
    ''' </summary>
    <TestInitialize()> Public Sub Initialize()
        ' TODO: Add test initialization code
    End Sub

    ''' <summary>
    ''' Cleanup() is called once during test execution after
    ''' test methods in this class have executed unless the
    ''' corresponding Initialize() call threw an exception.
    ''' </summary>
    <TestCleanup()> Public Sub Cleanup()
        ' TODO: Add test cleanup code
    End Sub

    <TestMethod()> Public Sub AlleBuchungen()
        Dim p As New de.WWWings.PassagierSystem.Passagier(1)

        Dim dr As System.Data.IDataReader = p.AlleBuchungen()

        Assert.IsNotNull(dr)
        Assert.IsTrue(dr.Read)
    End Sub

    <TestMethod()> Public Sub Buchen()
        Const FLUGNUMMER As Long = 100

        Dim p As New de.WWWings.PassagierSystem.Passagier("Mller", "Max")

        Dim b As de.WWWings.PassagierSystem.Buchung = p.Buchen(de.WWWings.Flug.GetFlug(FLUGNUMMER))

        Assert.IsTrue(b.Flug.FlugNr = FLUGNUMMER.ToString())
        Assert.IsTrue(b.Passagier.GanzerName = "Max Mller")

    End Sub


End Class
